proc pytest(hdd, nn);
    local dd, tauh, etah, delh, gamh, zeth, tdd, taut, etat, delt, gamt, zett, mss, mx;
    dd = rows(hdd);
    tauh = sumc(diag(hdd))/dd - 1; etah = dd/sumc(diag(inv(hdd))) -1; delh = (det(hdd))^(1/dd) - 1;
    gamh = delh - etah; zeth = tauh - delh;
    tdd  = inv(hdd); 
    taut = sumc(diag(tdd))/dd - 1; etat = dd/sumc(diag(inv(tdd))) -1; delt = (det(tdd))^(1/dd) - 1;
    gamt = delt - etat; zett = taut - delt;

    mss = zeros(12,1);
    mss[1,1] = nn*dd*(tauh^2 + 2*zeth)/2; mss[2,1] = nn*dd*(delh^2 + 2*zeth)/2; mss[3,1] = nn*dd*(delh^2 + 2*gamh)/2;
    mss[4,1] = nn*dd*(etah^2 + 2*gamh)/2; mss[5,1] = nn*dd*(tauh^2 + 2*gamh)/2; mss[6,1] = nn*dd*(etah^2 + 2*zeth)/2;
    mss[7,1] = nn*dd*(taut^2 + 2*zett)/2; mss[8,1] = nn*dd*(delt^2 + 2*zett)/2; mss[9,1] = nn*dd*(delt^2 + 2*gamt)/2;
    mss[10,1]= nn*dd*(etat^2 + 2*gamt)/2; mss[11,1]= nn*dd*(taut^2 + 2*gamt)/2; mss[12,1]= nn*dd*(etat^2 + 2*zett)/2;

    mx = maxc(mss[1:12,1]);
    retp(mx);
endp;
